import scipy.linalg
from src import tree
import src.factorization as fact
import src.utils as utils
import matplotlib.pyplot as plt
import scipy.fftpack
import numpy as np

from src.utils import matrix_product, best_perm, bit_reversal_permutation_matrix


def alternate_fac(A, support):
    #A: factorized matrix
    assert A.shape[0] == A.shape[1]
    set_perm = set()
    perm = np.zeros(A.shape)
    perm[np.arange(A.shape[0]), np.random.permutation(A.shape[0])] = 1
    #perm = np.identity(A.shape[0])
    lamda = 0.2
    loss = []
    for i in range(1000):
        root = tree.generate_balanced_tree(0, len(support), len(support))
        result = fact.tree_hierarchical_factorization(root, A @ perm)
        # result = fact.simple_hierarchical_factorization(support, A @ perm)
        B = matrix_product(result)
        new_perm = best_perm(A, B + utils.generate_matrix_noise(A.shape, 0, lamda))
        perm = np.zeros(A.shape)
        perm[np.arange(A.shape[0]), new_perm] = 1
        # if tuple(new_perm) in set_perm:
        #     #perm[np.arange(A.shape[0]), np.random.permutation(A.shape[0])] = 1
        #     #set_perm = set()
        #     print("Reinitialization")
        #     lamda = 1
        # else:
        #     set_perm.add(tuple(new_perm))
        #     #print(new_perm)
        #     lamda = 1
        #print(B)
        #print(A @ perm)
        print("Iteration ", i + 1, ": ",  np.linalg.norm(A @ perm - B))
        loss.append(np.linalg.norm(A @ perm - B))
    plt.plot(loss)
    plt.xlabel("iteration")
    plt.ylabel("relative error")
    plt.title(f"random, size {A.shape[0]}, noise={lamda}")
    plt.savefig(f"./random-size-{A.shape[0]}-noise-{lamda}.png")
    plt.show()
    plt.close()


if __name__ == '__main__':
    n = 4
    true_perm = bit_reversal_permutation_matrix(n)
    #true_perm[np.arange(2 ** n) , np.random.permutation(2 ** n)] = 1
    print(true_perm)
    support = utils.support_DFT(n)
    # A = scipy.linalg.hadamard(2 ** n) @ true_perm
    A = utils.generate_random_matrix(support)
    print(scipy.linalg.hadamard(2 ** n))
    print(A)
    alternate_fac(A, support)
