import numpy as np

from src import utils as utils
from src.archive.dictionary import learning_with_butterfly_model
from src.utils import add_padding


def experience1():
    k = 5
    num_factors = 3
    supp = utils.support_DFT(num_factors)
    num_rows = 2 ** num_factors
    num_cols = 3 * num_rows
    true_gamma = np.zeros((num_rows, num_cols))
    for i in range(num_cols):
        subset = np.random.permutation(np.arange(num_rows))[:k]
        true_gamma[subset, i] = 1
    print(true_gamma)
    true_M = utils.generate_random_matrix(supp) @ true_gamma
    M_pad = add_padding(true_M)
    print(M_pad.shape)
    factors, gamma, _ = learning_with_butterfly_model(M_pad, 5, 1000)
    all_factors = factors + [gamma]
    print(utils.error_cal(all_factors, M_pad))