"""
Comparing the lifting factorization method with DTO factorization method, when fixing the butterfly supports as the
sparsity constraints.
"""

import src.factorization as fact
import src.utils as utils
import scipy.linalg
import time
import src.tree as tree

if __name__ == '__main__':
    num_factors = 12
    supp = utils.support_DFT(num_factors)
    matrix = scipy.linalg.hadamard(2 ** num_factors)
    root = tree.generate_balanced_tree(0, num_factors, num_factors)

    begin = time.time()
    result = fact.tree_hierarchical_factorization(root, matrix, method='lifting')
    end = time.time()
    loss = utils.error_cal(result, matrix)
    print(end - begin, loss)

    begin = time.time()
    result = fact.tree_hierarchical_factorization(root, matrix, method='DTO')
    end = time.time()
    loss = utils.error_cal(result, matrix)
    print(end - begin, loss)
