import scipy
import src.utils as utils
import numpy as np
import src.archive.optimization as optim
import matplotlib.pyplot as plt

if __name__ == '__main__':
    matrix = scipy.linalg.hadamard(2 ** 2)
    supp = utils.support_DFT(2)
    main_std = 1
    main_m = 0

    left_supp = np.multiply(supp[0], np.random.binomial(size=supp[0].shape, n=1, p=0.5) * 2 - 1)
    right_supp = np.multiply(supp[1], np.random.binomial(size=supp[1].shape, n=1, p=0.5) * 2 - 1)
    X = np.multiply(np.random.randn(left_supp.shape[0], left_supp.shape[1]) * main_std + main_m, left_supp)
    Y = np.multiply(np.random.randn(right_supp.shape[0], right_supp.shape[1]) * main_std + main_m, right_supp)

    print(X, Y)

    gradient_method = optim.FixedSupportGradientOptimization(matrix, [1, 1, 0], X, Y, np.identity(4), cuda=False)
    losses, best = gradient_method.train(lr=0.01, verbose_freq=100, num_iter=1000)
    X, Y, P = gradient_method.return_numpy_masked_factors()
    print(X)
    print(Y)
    print(X @ Y @ P)

    plt.plot(losses)
    plt.show()
