import argparse
import scipy

import numpy as np
import src.factorization as fact

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description="BP projection with fixed P")
    parser.add_argument("--num_factors", type=int, default=3)
    parser.add_argument("--matrix", choices=["dft", "hadamard"], default="dft")
    parser.add_argument("--tree", choices=["comb", "balanced"], default="comb")
    args = parser.parse_args()

    if args.matrix == "dft":
        matrix = scipy.linalg.dft(2 ** args.num_factors)
    else:
        assert args.matrix == "hadamard"
        matrix = scipy.linalg.hadamard(2 ** args.num_factors)

    projection = fact.project_BP_model_8_perm_fixed(matrix, args.tree, max_depth=-1)

    print(np.linalg.norm(matrix - projection) / (np.linalg.norm(matrix) + 1e-15))
